
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================
`include "vpg.h"

module DE10_Standard_HDMI_TX(

	//////////// CLOCK //////////
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	input 		          		CLOCK4_50,
	input 		          		CLOCK_50,

	//////////// KEY //////////
	input 		     [3:0]		KEY,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// Seg7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// Video-In //////////
	input 		          		TD_CLK27,
	input 		     [7:0]		TD_DATA,
	input 		          		TD_HS,
	output		          		TD_RESET_N,
	input 		          		TD_VS,

	//////////// VGA //////////
	output		          		VGA_BLANK_N,
	output		     [7:0]		VGA_B,
	output		          		VGA_CLK,
	output		     [7:0]		VGA_G,
	output		          		VGA_HS,
	output		     [7:0]		VGA_R,
	output		          		VGA_SYNC_N,
	output		          		VGA_VS,

	//////////// Audio //////////
	input 		          		AUD_ADCDAT,
	inout 		          		AUD_ADCLRCK,
	inout 		          		AUD_BCLK,
	output		          		AUD_DACDAT,
	inout 		          		AUD_DACLRCK,
	output		          		AUD_XCK,

	//////////// PS2 //////////
	inout 		          		PS2_CLK,
	inout 		          		PS2_CLK2,
	inout 		          		PS2_DAT,
	inout 		          		PS2_DAT2,

	//////////// ADC //////////
	output		          		ADC_CONVST,
	output		          		ADC_DIN,
	input 		          		ADC_DOUT,
	output		          		ADC_SCLK,

	//////////// I2C for Audio and Video-In //////////
	output		          		FPGA_I2C_SCLK,
	inout 		          		FPGA_I2C_SDAT,

	//////////// IR //////////
	input 		          		IRDA_RXD,
	output		          		IRDA_TXD,

	//////////// HSMC, HSMC connect to HDMI TX //////////
	output		          		HDMI_TX_SCL,
	inout 		          		HDMI_TX_SDA,
	output		    [11:0]		TX_BD,
	inout 		          		TX_CEC,
	output		          		TX_DCLK,
	output		          		TX_DE,
	output		          		TX_DSR0L,
	output		          		TX_DSR0R,
	output		          		TX_DSR1L,
	output		          		TX_DSR1R,
	output		          		TX_DSR2L,
	output		          		TX_DSR2R,
	output		          		TX_DSR3L,
	output		          		TX_DSR3R,
	output		    [11:0]		TX_GD,
	output		          		TX_HS,
	output		     [3:0]		TX_I2S,
	input 		          		TX_INT_N,
	output		          		TX_MCLK,
	output		          		TX_PCLK,
	output		          		TX_PCSCL,
	inout 		          		TX_PCSDA,
	output		    [11:0]		TX_RD,
	output		          		TX_RST_N,
	output		          		TX_SCK,
	output		          		TX_SPDIF,
	output		          		TX_VS,
	output		          		TX_WS
	
);


//assign SMA_CLKOUT = HDMI_TX_PCLK;
//=======================================================
//  REG/WIRE declarations
//=======================================================


wire reset_n;
wire pll_100M;

wire gen_sck;
wire gen_i2s;
wire gen_ws;

system_pll system_pll_inst(
		.refclk(CLOCK_50),   //  refclk.clk
		.rst(1'b0),      //   reset.reset
		.outclk_0(pll_100M), // outclk0.clk
		.outclk_1(gen_sck), // outclk1.clk
		.locked(reset_n)    //  locked.export
	);
						  
						  
Qsys u0 (
        .clk_clk                                        (CLOCK3_50),                                        //                                     clk.clk
        .reset_reset_n                                  (reset_n),                                  //                                   reset.reset_n
        
		  // the_hdmi_tx_disp_mode
        .hdmi_tx_disp_mode_external_connection_export   (vpg_disp_mode),   
		  
		  // the_hdmi_tx_i2c_scl
        .hdmi_tx_i2c_scl_external_connection_export     (TX_PCSCL),     
		  
		  // the_hdmi_tx_i2c_sda
		  .hdmi_tx_i2c_sda_external_connection_export	  (TX_PCSDA),
		  
		  // the_hdmi_tx_irq_n
        .hdmi_tx_irq_n_external_connection_export       (TX_INT_N),      

		  // the_hdmi_tx_mode_change
		  .hdmi_tx_mode_change_external_connection_export (vpg_disp_mode_change),
		  
		  // the_hdmi_tx_reset_n
		  .hdmi_tx_reset_n_external_connection_export     (TX_RST_N),
		  
        // the_hdmi_tx_vpg_color
        .hdmi_tx_vpg_color_external_connection_export	  (vpg_disp_color),

        // the_i2s_tx
        .i2s_tx_conduit_end_sck                     	  (gen_sck),
        .i2s_tx_conduit_end_sd                    		  (gen_i2s),
        .i2s_tx_conduit_end_ws                    		  (gen_ws),

		  // the_pio_button
        .pio_button_external_connection_export          (KEY[1:0]),

		  // the_pio_led
		  .pio_led_external_connection_export         	  (LEDR[3:0])

    );

//============== video pattern generator =====================
//wire 		user_change_mode;
wire 					vpg_disp_mode_change;
wire 		[3:0]		vpg_disp_mode;
wire 		[1:0]		vpg_disp_color;

wire 					vpg_pclk;
wire 					vpg_de;
wire 					vpg_hs;
wire 					vpg_vs;
wire 		[7:0]		vpg_r;
wire 		[7:0]		vpg_g;
wire 		[7:0]		vpg_b;


vpg	vpg_inst(
               .CLOCK2_50(CLOCK2_50),
					.CLOCK3_50(CLOCK3_50),
					.CLOCK4_50(CLOCK4_50),
					.clk_100    (pll_100M),
					.reset_n    (reset_n),
					.mode       (vpg_disp_mode) ,
					.mode_change(vpg_disp_mode_change) ,
					.disp_color (vpg_disp_color),
					.vpg_pclk   (vpg_pclk      ),
					.vpg_de     (vpg_de),
					.vpg_hs     (vpg_hs),
					.vpg_vs     (vpg_vs),
					.vpg_r      (vpg_r),
					.vpg_g      (vpg_g),
					.vpg_b      (vpg_b)				
					);

//===== source selection, from pattern generator or hdmi-rx
wire	 rx_sync;

clk_slector clk_slector_inst(
								     .data0 (~vpg_pclk),
									  .data1 (RX_PCLK),
									  .sel   (rx_sync),
									  .result(TX_PCLK)//HDMI_TX_PCLK)
									);	
	//assign HDMI_TX_PCLK = clk_65M;							
source_selector source_selector_inst(
												 .data0x({vpg_de, vpg_hs, vpg_vs, vpg_r, 4'b0000, vpg_g, 4'b0000, vpg_b, 4'b0000}),
												 .data1x({rx_de, rx_hs, rx_vs, rx_r,rx_g,rx_b}),
												 .sel   (rx_sync),
												 .result({TX_DE, TX_HS, TX_VS, TX_RD,TX_GD,TX_BD})
												);
//=== audio
//assign HDMI_TX_MCLK 	= HDMI_RX_MCLK;
// i2s
assign HDMI_TX_SCK = gen_sck;
assign HDMI_TX_I2S = {gen_i2s, gen_i2s, gen_i2s, gen_i2s};
assign HDMI_TX_WS  = gen_ws;


												
endmodule
