module Example_SM (
input clk,reset,
input[31:0] mgmt_readdata,
input mgmt_waitrequest,
input [2:0] mif_sel,
output reg mgmt_read,
output reg mgmt_write,
output reg [5:0] mgmt_address,
output reg [31:0] mgmt_writedata,
output reg [3:0] state,
output    [31:0] temp_data,
output     [5:0] temp_address


); 


reg [3:0] write_count;

//`define PLL_27		0 0 
//`define PLL_65		1 46
//`define PLL_74.25	2 92
//`define PLL_108		3 138
//`define PLL_148.5	4 184
//`define PLL_162		5 230
assign temp_address =6'h1F;  
assign temp_data  = (
(mif_sel==0) ? 0  : (
(mif_sel==1) ? 46 : (
(mif_sel==2) ? 92 : (
(mif_sel==3) ? 138 : (
(mif_sel==4) ? 184 : (
(mif_sel==5) ? 230 : 230
))))));


//always @ (mif_sel)
//begin
//
//	case (mif_sel)
//	3'b000 :
//		begin
//		temp_address <=6'h1F; //mif reg
//		temp_data    <=32'd0;    //mif base address
//		end
//
//	3'b011 :
//		begin
//		temp_address <=6'h06;    //DPS
//		temp_data <=32'h210005;   //positive phase shift on C1 for 5 steps
//		end
//		
//	3'b100 :
//		begin
//		temp_address <=6'h05;    //Change C0 to 10
//		temp_data <=32'h0505;   
//		end
//		
//	3'b101 :
//		begin
//		temp_address <=6'h05;    //Change C0 to 20
//		temp_data <=32'h0A0A; 
// 		end
//
//   3'b110:
//		begin
//		temp_address <=6'h3F;   //Return the mif_reg_asserted to 0
//		temp_data <=32'h0;  		//Do nothing
//		end
//		
//	default:
//		begin
//		temp_address <=6'h3F;   //Do nothing 3F not defined for any register
//		temp_data <=32'h0;  		//Do nothing
//		end
//
	
		
	//
	//endcase

//end		
	


always @ (posedge clk or posedge reset)
begin
	if (reset == 1'b1)
	begin
		state         <= 4'b0000;
		mgmt_read     <=1'b0;
		mgmt_write    <=1'b0;
	   mgmt_address  <=5'b00000;
	   mgmt_writedata<=32'h00000000;	
		write_count   <=4'b0000;
	end

   else 
	begin

		case (state)
			4'b0000: 
				begin
					state        <= 4'b0001;
					mgmt_read    <=1'b0;
		         mgmt_write   <=1'b0;
					mgmt_address <=6'b000000;
					mgmt_writedata<=32'h00000000;	
					//Setting up data : Mode Register(Add=0), Data=0 , Mode=Waitrequest
		  		end
				
			4'b0001: 
				begin
					write_count   <=write_count+1'b1;
					mgmt_read     <=1'b0;
		         mgmt_address  <=6'b000000;
					mgmt_writedata<=32'h00000000;	
					if(write_count==4'b0000) mgmt_write<=1'b1; else mgmt_write<=1'b0;	
					
					if(write_count==4'b0001)
					  	begin 
								state <= 4'b0010;
								write_count<=4'b0000;
					   end
					
				    else state<=4'b0001;
					   
					//Writing to Mode Register
				   	
		  		end
				
			4'b0010: 
				begin
					state     <= 4'b0011;
					mgmt_read <=1'b0;
		         mgmt_write<=1'b0;
					//mgmt_address<=6'h06;
					//mgmt_writedata<=32'h210005;
					mgmt_address   <=temp_address;
					mgmt_writedata <=temp_data;
					//Setting up data, Writing to MIF Base Address Register
		  		end
				
				
			4'b0011: 
				begin
					write_count<=write_count+1'b1;
					mgmt_read<=1'b0;
					//mgmt_address<=6'h06;
					//mgmt_writedata<=32'h210005;
					mgmt_address  <=temp_address;
					mgmt_writedata<=temp_data;
					//Writing to MIF Base Address Register
					
					if(write_count==4'b0000)
				      begin
						mgmt_write<=1'b1;
                  end

		            else mgmt_write<=1'b0;
						
					if(write_count==4'b0001)
					  	begin 
								state <= 4'b0100;
								write_count<=4'b0000;
					   end
					
				   else state<=4'b0011;
		  		end
				
				
	
				
			4'b0100: 
				begin
					state      <= 4'b0101;
					mgmt_read  <=1'b0;
		         mgmt_write     <=1'b0;
		        	mgmt_address   <=6'b000010;
					mgmt_writedata <=32'b00000000000000000000000000000001;	
					//Setting up data 
		  		end
				
		  4'b0101: 
				begin
					write_count<=write_count+1'b1;
					mgmt_read<=1'b0;
		        	mgmt_address<=6'b000010;
					mgmt_writedata<=32'b00000000000000000000000000000001;	
					//Writing to Start Register
					
					if(write_count==4'b0000)
					  	begin 
								mgmt_write <= 1'b1;
						end
					
				   else mgmt_write<=1'b0;
					
										
					if(write_count==4'b001)
					  	begin 
								state <= 4'b0110;
								write_count<=4'b0000;
					   end
					
				   else state<=4'b0101;
		  		end			
				
		  4'b0110: 
				begin
				   state <= 4'b0111;
					mgmt_read<=1'b0;
		         mgmt_write<=1'b0;
					mgmt_address<=6'b000001;
					mgmt_writedata<=32'b00000000000000000000000000000001;	
					//Setting to read from status Register
		  		end	
				
			4'b0111: 
				begin
				   mgmt_read<=1'b0;
		         mgmt_write<=1'b0;
					mgmt_address<=6'b000001;
					
					if (mgmt_waitrequest==1'b0) 
					   begin 
								state <= 4'b1000;
					   end
					
				   else state<=4'b0111;
			//only proceed to next operation if status register =1
					
				end	
				
			4'b1000: 
				begin
					mgmt_read<=1'b0;
					mgmt_write<=1'b0;
					mgmt_address<=6'b000000;
					mgmt_writedata<=32'h00000000;	
					//No activity after DPS complete
				end
			
		 default:
		     begin
					mgmt_read<=1'b0;
					mgmt_write<=1'b0;
					mgmt_address<=6'b000000;
					mgmt_writedata<=32'h00000000;	
	        end		
		  			
	endcase
	
	end
end

endmodule
