// Copyright (C) 2017  Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions 
// and other software and tools, and its AMPP partner logic 
// functions, and any output files from any of the foregoing 
// (including device programming or simulation files), and any 
// associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License 
// Subscription Agreement, the Intel Quartus Prime License Agreement,
// the Intel MegaCore Function License Agreement, or other 
// applicable license agreement, including, without limitation, 
// that your use is for the sole purpose of programming logic 
// devices manufactured by Intel and sold by Intel or its 
// authorized distributors.  Please refer to the applicable 
// agreement for further details.

// PROGRAM		"Quartus Prime"
// VERSION		"Version 16.1.2 Build 203 01/18/2017 SJ Standard Edition"
// CREATED		"Mon Nov 05 09:29:54 2018"

module  PLL_SETTING(
input wire	refclk,
input wire	reset,
input wire	reset_SM,
input wire	mgmt_reset,
input wire	[2:0] mif_sel,
output wire	C0,
output wire	C1,
output wire	locked,
output wire	pll_busy

);

//---- io 


//------wire 
wire	       mgmt_read;
wire	       mgmt_write;
wire	[5:0]  mgmt_address;
wire	[31:0] mgmt_writedata;
wire	[63:0] reconfig_from_pll;
wire	[63:0] reconfig_to_pll;
wire	       reset_sm , reset_an ,reset_mgmt  ;
wire         locked_; 
wire	       mgmt_waitrequest;
wire	[31:0] mgmt_readdata;





PLL_RECONFIG_AN	b2v_inst(
	.mgmt_clk(refclk),
	.mgmt_reset(reset_mgmt),
	.mgmt_read(mgmt_read),
	.mgmt_write(mgmt_write),
	.mgmt_address(mgmt_address),
	.mgmt_writedata(mgmt_writedata),
	.reconfig_from_pll(reconfig_from_pll),
	.mgmt_waitrequest(mgmt_waitrequest),
	.mgmt_readdata(mgmt_readdata),
	.reconfig_to_pll(reconfig_to_pll));


PLL_AN	b2v_inst1(
	.refclk (refclk),
	.rst    (reset_an),
	.reconfig_to_pll(reconfig_to_pll),
	.outclk_0(C0),

	.locked(locked_),
	.reconfig_from_pll(reconfig_from_pll));


	
	
	
	
Example_SM	b2v_inst2(
	.clk (refclk),
	.reset    (reset_sm),
	.mgmt_waitrequest(mgmt_waitrequest),
	.mgmt_readdata   (mgmt_readdata),
	.mif_sel         (mif_sel),
	.mgmt_read       (mgmt_read),
	.mgmt_write      (mgmt_write),
	.mgmt_address(mgmt_address),
	.mgmt_writedata(mgmt_writedata));
 
assign   pll_busy   = mgmt_waitrequest ; 
assign	locked     =  locked_;

assign	reset_mgmt =  ~mgmt_reset;
assign	reset_an   =  ~reset;
assign	reset_sm   =  reset_SM;

endmodule
