// --------------------------------------------------------------------
// Copyright (c) 2007 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
// --------------------------------------------------------------------
//
// Major Functions:	HDMI TX only 
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Allen  Wang       :| 10/25/10  :| Initial Revision
//   V1.1 :| Tony   Zhou       :| 3/8/2011  :| support to HDMI 1.4

//---------------------------------------------------------------------
`include "vpg.h"

//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================
module DE2_115_HDMI_TX(

		////////// CLOCK //////////////
		OSC_50,
      SMA_CLKOUT,
		////////// LED ////////////////
		LED,  

		////////// BUTTON /////////////
		BUTTON,

		////////// HSMC Port //////////
		HDMI_TX_GD,
		HDMI_TX_RD,
		HDMI_TX_PCSCL,
		HDMI_TX_PCSDA,
		HDMI_TX_RST_N,
		HDMI_TX_INT_N,
		HDMI_TX_DSD_L,
		HDMI_TX_DSD_R,
		HDMI_TX_BD,
		HDMI_TX_PCLK,
		HDMI_TX_DCLK,
		HDMI_TX_SCK,
		HDMI_TX_WS,
		HDMI_TX_MCLK,
		HDMI_TX_I2S,
		HDMI_TX_DE,
		HDMI_TX_VS,
		HDMI_TX_HS,
		HDMI_TX_SPDIF,
		HDMI_TX_CEC
	);

//=======================================================
//  PARAMETER declarations
//=======================================================

//=======================================================
//  PORT declarations
//=======================================================
////////// CLOCK //////////
input									OSC_50;


////////// LED //////////
output    	[3:0]           	LED;

////////// BUTTON //////////
input     	[3:0]           	BUTTON;

////////// HSMC Port  //////////
output    	[11:0]          	HDMI_TX_RD;
output                    		HDMI_TX_PCSCL;
inout                     		HDMI_TX_PCSDA;
output                    		HDMI_TX_RST_N;
input                     		HDMI_TX_INT_N;
output    	[11:0]          	HDMI_TX_GD;
output                    		HDMI_TX_PCLK;
output    	[3:0]           	HDMI_TX_DSD_L;
output    	[3:0]           	HDMI_TX_DSD_R;
output                    		HDMI_TX_DCLK;
output                    		HDMI_TX_SCK;
output                    		HDMI_TX_WS;
output                    		HDMI_TX_MCLK;
output    	[3:0]           	HDMI_TX_I2S;
output    	[11:0]          	HDMI_TX_BD;
output                    		HDMI_TX_DE;
output                    		HDMI_TX_VS;
output                    		HDMI_TX_HS;
output                    		HDMI_TX_SPDIF;
inout                     		HDMI_TX_CEC;

output                        SMA_CLKOUT;

assign SMA_CLKOUT = HDMI_TX_PCLK;
//=======================================================
//  REG/WIRE declarations
//=======================================================


wire reset_n;
wire pll_100M;

wire gen_sck;
wire gen_i2s;
wire gen_ws;


sys_pll sys_pll_inst(
							.areset(1'b0),
							.inclk0(OSC_50),
							.c0    (pll_100M),
							.c1    (gen_sck),
							.locked(reset_n)
						  );


DE2_115_HDMI_TX_SOPC     U1         (
                                 // 1) global signals:
                                  .clk(pll_100M),
                                  //.pll_cpu(),
                                  //.pll_io(),
                                  .reset_n(reset_n),

                                 // the_hdmi_tx_disp_mode
                                  .out_port_from_the_hdmi_tx_disp_mode       (vpg_disp_mode),

                                 // the_hdmi_tx_i2c_scl
                                  .out_port_from_the_hdmi_tx_i2c_scl         (HDMI_TX_PCSCL),

                                 // the_hdmi_tx_i2c_sda
                                  .bidir_port_to_and_from_the_hdmi_tx_i2c_sda(HDMI_TX_PCSDA),

                                 // the_hdmi_tx_irq_n
                                  .in_port_to_the_hdmi_tx_irq_n              (HDMI_TX_INT_N),

                                 // the_hdmi_tx_mode_change
                                  .out_port_from_the_hdmi_tx_mode_change     (vpg_disp_mode_change),

                                 // the_hdmi_tx_reset_n
                                  .out_port_from_the_hdmi_tx_reset_n         (HDMI_TX_RST_N),

                                 // the_hdmi_tx_vpg_color
                                  .out_port_from_the_hdmi_tx_vpg_color       (vpg_disp_color),

                                 // the_i2s_tx
                                  .i2s_sck_to_the_i2s_tx                     (gen_sck),
                                  .i2s_sd_from_the_i2s_tx                    (gen_i2s),
                                  .i2s_ws_from_the_i2s_tx                    (gen_ws),

                                 // the_pio_button
                                  .in_port_to_the_pio_button                 (BUTTON),

                                 // the_pio_led
                             //     .out_port_from_the_pio_led                 (LED[3:0]),

                                 // the_pll
                                  .locked_from_the_pll(),
                                  .phasedone_from_the_pll()
                               )
;

//============== video pattern generator =====================
//wire 		user_change_mode;
wire 					vpg_disp_mode_change;
wire 		[3:0]		vpg_disp_mode;
wire 		[1:0]		vpg_disp_color;

wire 					vpg_pclk;
wire 					vpg_de;
wire 					vpg_hs;
wire 					vpg_vs;
wire 		[7:0]		vpg_r;
wire 		[7:0]		vpg_g;
wire 		[7:0]		vpg_b;


vpg	vpg_inst(
					.clk_100    (pll_100M),
					.reset_n    (reset_n),
					.mode       (vpg_disp_mode       ),
					.mode_change(vpg_disp_mode_change),
					.disp_color (vpg_disp_color),
					.vpg_pclk   (vpg_pclk      ),
					.vpg_de     (vpg_de),
					.vpg_hs     (vpg_hs),
					.vpg_vs     (vpg_vs),
					.vpg_r      (vpg_r),
					.vpg_g      (vpg_g),
					.vpg_b      (vpg_b)
					);

//===== source selection, from pattern generator or hdmi-rx
wire	 rx_sync;

clk_slector clk_slector_inst(
								     .data0 (~vpg_pclk),
									  .data1 (HDMI_RX_PCLK),
									  .sel   (rx_sync),
									  .result(HDMI_TX_PCLK)//HDMI_TX_PCLK)
									);	
	//assign HDMI_TX_PCLK = clk_65M;							
source_selector source_selector_inst(
												 .data0x({vpg_de, vpg_hs, vpg_vs, vpg_r, 4'b0000, vpg_g, 4'b0000, vpg_b, 4'b0000}),
												 .data1x({rx_de, rx_hs, rx_vs, rx_r,rx_g,rx_b}),
												 .sel   (rx_sync),
												 .result({HDMI_TX_DE, HDMI_TX_HS, HDMI_TX_VS, HDMI_TX_RD,HDMI_TX_GD,HDMI_TX_BD})
												);
//=== audio
//assign HDMI_TX_MCLK 	= HDMI_RX_MCLK;
// i2s
assign HDMI_TX_SCK = gen_sck;
assign HDMI_TX_I2S = {gen_i2s, gen_i2s, gen_i2s, gen_i2s};
assign HDMI_TX_WS  = gen_ws;


assign LED = HZ  ; 
//----freqtest
////=======================================================
////  Structural coding
////=======================================================

wire [2:0]HZ ; 
CLOCKMEM u1(  .RESET_n(1),  .CLK  (OSC_50  ), .CLK_FREQ (50000000), .CK_1HZ (HZ[0]) ) ;
CLOCKMEM u2(  .RESET_n(1),  .CLK  (pll_100M), .CLK_FREQ (100000000), .CK_1HZ (HZ[1]) ) ;
CLOCKMEM u3(  .RESET_n(1),  .CLK  (vpg_pclk), .CLK_FREQ (27000000), .CK_1HZ (HZ[2]) ) ;


wire [35:0] FREQ_pll_100M ;  
wire [35:0] FREQ_vpg_pclk ; 


//--1S generater 
wire M50_1HZ ; 
CLOCKMEM  ck2( .RESET_n(BUTTON[0]), .CLK(OSC_50 ) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;

//--U26
FRE_MEASURE mes1 ( .RESET_n(BUTTON[0]),.MES_CLK (pll_100M)   , .HZ1(M50_1HZ) , .FREQ(FREQ_pll_100M)); 
FRE_MEASURE mes4 ( .RESET_n(BUTTON[0]),.MES_CLK (vpg_pclk)   , .HZ1(M50_1HZ) , .FREQ(FREQ_vpg_pclk)); 
																	
		
//
//--View for SingalTapeii
TP t(
    .CLK                  ( pll_100M        ),
    .TR                   ( M50_1HZ           ), 
    .FREQ_pll_100M  ( FREQ_pll_100M), 
    .FREQ_vpg_pclk  ( FREQ_vpg_pclk),
    .HDMI_TX_PCSCL(HDMI_TX_PCSCL),
    .HDMI_TX_PCSDA(HDMI_TX_PCSDA)	 
	 
	 
	 ) ; 
	
												
endmodule
